#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

unsigned W=0; //Wolf
unsigned G=0; //Goat
unsigned C=0; //Cabbage
unsigned R=0; //Raft

void check()
{
    if (W==G && G!=R)
    {
        printf("Wolf has eaten Goat.\n");
        exit(0);
    }

    if (C==G && G!=R)
    {
        printf("Goat has eaten Cabbage.\n");
        exit(0);
    }
}

void print_situation()
{
    const char* middle=" --river-- ";
    char w0,w1,g0,g1,c0,c1,r0,r1;

    if (W==1) {w0=' '; w1='W';} else {w0='W'; w1=' ';};
    if (G==1) {g0=' '; g1='G';} else {g0='G'; g1=' ';};
    if (C==1) {c0=' '; c1='C';} else {c0='C'; c1=' ';};
    if (R==1) {r0=' '; r1='R';} else {r0='R'; r1=' ';};

    printf("-------------\n");
    printf("%c%s%c\n",w0,middle,w1);
    printf("%c%s%c\n",g0,middle,g1);
    printf("%c%s%c\n",c0,middle,c1);
    printf("%c%s%c\n",r0,middle,r1);
    printf("-------------\n");
}


int main()
{
    while ( (R+W+G+C!=4) )
    {
        char c;
        check();
        print_situation();
	printf("Who shall go next?\n");
	if (W==R) printf(" w -- raft and wolf\n");
	if (G==R) printf(" g -- raft and goat\n");
	if (C==R) printf(" c -- raft and cabbage\n");
	printf(" r -- raft only\n");
	printf("Your choice: ");
        scanf("%c",&c);


	
	
        switch (c)
        {
        case 'w':
            if (W==R)
            {
                W=1-W;                
                R=1-R;
            }
            else printf("Invalid move.\n");
            break;
        case 'g':
            if (G==R)
            {
                G=1-G;                
                R=1-R;
            }
            else printf("Invalid move.\n");
            break;
        case 'c':
            if (C==R)
            {
                C=1-C;                
                R=1-R;
            }
            else printf("Invalid move.\n");
            break;
        case 'r':
            R=1-R;
            break;
        default:
  	    printf("Unknown command!\n");
        }

	printf("\n");
        
    }
    printf("Good. You passed the river.\n");
    assert(0);        
    return 0;
}
